--Samples points offset from the colliding object, returns the normal of the gradient
function samplePoints(p, f, offset, params)
	local eps = 1e-4
	local ds = {f(p.x + eps -offset.x, p.y-offset.y, table.unpack(params)),
			f(p.x - eps-offset.x, p.y-offset.y, table.unpack(params)),
			f(p.x-offset.x, p.y + eps-offset.y, table.unpack(params)),
			f(p.x-offset.x, p.y - eps-offset.y, table.unpack(params))}
	return vec2.new((ds[1]-ds[2])/(2*eps), (ds[3]-ds[4])/(2*eps)):normalized()
end

function checkCollision(p,o,r)
	local f = o[1]
	local dist = f(p.position.x - o[2].x, p.position.y - o[2].y, table.unpack(o[3])) -- check shape collision detection
	if dist < p.radius then
		local normal = samplePoints(p.position, f, o[2], o[3]) -- calculate gradient
		p.position = p.position + normal * ((p.radius - dist) + 0.12) --push penetration out
		return normal
	else
		return nil
	end
end