io.stdout:setvbuf('no')


require("vec2")
require("collision")
require("ball")
require("sdf")


ball1 = Ball.new(280,0)

shader_code = [[

uniform vec2 pos;

//GLSL version of the Horseshoe primitive SDF
float sdHorseshoe( in vec2 p, in vec2 c, in float r, in float le, float th )
{
    p.x = abs(p.x);
    float l = length(p);
    p = mat2(-c.x, c.y, 
              c.y, c.x)*p;
    p = vec2((p.y>0.0 || p.x>0.0)?p.x:l*sign(-c.x),
             (p.x>0.0)?p.y:l );
    p = vec2(p.x-le,abs(p.y-r)-th);
    return length(max(p,0.0)) + min(0.0,max(p.x,p.y));
}



vec4 effect(vec4 color, Image image, vec2 texture_coords, vec2 screen_coords){
    
    //Fix to the coord mapping problem. It's probably wrong, I just guessed it
    float height = love_ScreenSize.y;
    vec2 p = screen_coords/height;

    //Calling SDF per position on screen. Position is passed as a uniform, other params should be too. Everything scaled by height.
    float d = sdHorseshoe(pos - p, vec2(20,50)/height, 144.0/height, 20.0/height, 2/height);
    
    //Inside the SDF is white
    vec3 col = (d > 0.0) ? vec3(0.0,0.0,0.0) : vec3(1.0,1.0,1.0);
    return vec4(col,1.0);
}
]]


function love.load()

    --Position of the SDF, to be used on both CPU and GPU
    local pos =  vec2.new(400,300)

    --Holds SDFs to check collisions
    terrain = {}
    table.insert(terrain, {sdHorseshoe, pos, {20, 50, 144, 20, 2}})

    sdf_shader = love.graphics.newShader(shader_code)

    --Passing the arguments to the SDF function inside the shader
    hgt = love.graphics.getHeight()
    sdf_shader:send("pos", {pos.x/hgt,pos.y/hgt}) --Screen position scaled to height. Other parameters are hardcoded on the shader, but should be passed along too
    
    canvas = love.graphics.newCanvas( )
end

function love.update(dt)
    for i=1,4 do 
        ball1:update(dt)
    end
end
function love.draw()
    love.graphics.setShader(sdf_shader)
        love.graphics.draw(canvas)
    love.graphics.setShader()

    ball1:draw()
end